﻿#pragma once
#include "stdafx.h"
#include <iostream>
#include <vector>

namespace WinDevice {
    struct OsInfo {
        // 操作系统名称
        std::string name;     
        unsigned long majorVersion;
        unsigned long minorVersion;
        unsigned long buildNumber;
        // 总内存大小（以字节为单位）
        int64_t totalMemory;    
    };

    struct CpuInfo {
        std::string name;
        int coreCout;
    };

    struct GpuInfo {
        std::string name;
        /**
         *  \brief 厂商Id
         *
         * 可能的值：
         * - NVIDIA:0x10DE
         * - Intel :0x8086
         * - AMD   :0x1002
         */
        uint32_t vendorId;
        uint32_t deviceId;
        size_t vram;
    };

    struct DisplayMonitorInfo {
        std::shared_ptr<HMONITOR> monitor;
        std::string name;
        long width;
        long height;
    };

    struct UserDeviceInfo {
        std::shared_ptr<CpuInfo> cpu;
        std::shared_ptr<OsInfo> os;
        std::shared_ptr<std::vector<GpuInfo>> gpu;
        std::shared_ptr<std::vector<DisplayMonitorInfo>> monitor;
    };
}
